stages:
  - build

variables:
  REGISTRY: "registry.gitlab.com"
  REPO_NAME: "geosales-open-source/sandbox/fastlane-linux-flutter-android-dockerimage"
  IMAGE_VERSION: "0.0.9"

build_and_push_image:
  stage: build
  image: docker:19.03.12
  tags:
    - dind
  services:
    - docker:19.03.12-dind
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_TLS_CERTDIR: ""
  before_script:
    - apk add make
    - docker login "$CI_REGISTRY" --username "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD"

  script:
    - sed -i "s#^REGISTRY=.*#REGISTRY=${REGISTRY}#" Makefile
    - sed -i "s#^REPO_NAME=.*#REPO_NAME=${REPO_NAME}#" Makefile
    - sed -i "s#^IMAGE_VERSION=.*#IMAGE_VERSION=${IMAGE_VERSION}#" Makefile
    - if docker pull "$REGISTRY/$REPO_NAME:$IMAGE_VERSION"; then
    -   echo "Version already built $REGISTRY/$REPO_NAME:$IMAGE_VERSION, aborting..." >&2
    -   exit 1
    - fi
    - make build
    - docker push registry.gitlab.com/geosales-open-source/sandbox/fastlane-linux-flutter-android-dockerimage:latest
    - docker push registry.gitlab.com/geosales-open-source/sandbox/fastlane-linux-flutter-android-dockerimage:$IMAGE_VERSION
  only:
    - tags
    - main